﻿@inject ITextTheme TextTheme
@inject IBackgroundTheme BackgroundTheme
@inject HttpClient _client

<CascadingValue Name="Modal" Value="@this">
    <Modal @ref="modalRef" Class="directory-modal">
        <ModalContent IsCentered="true" Size="ModalSize.Large" Class="directory-modal-content">
            <ModalHeader Class="directory-modal-header">
                <ModalTitle>New library</ModalTitle>
                <CloseButton Class="directory-modal-header-close" Clicked="@HideModal" />
            </ModalHeader>
            <ModalBody Class="directory-modal-body">
                <Container Class="row directory-modal-body-content">
                    <Container Class="col-6">
                        <Container Class="directory-modal-body-content-left">
                            @foreach ( var item in Disks.Disks ) {
                                <Container @onclick="() => ChangeLibraryPath(item)">
                                    <Icon Name="@("fa-hdd")" />
                                    <Text Class="directory-modal-body-content-left-disk">@item</Text>
                                </Container>
                            }
                        </Container>
                        <Container>
                            <Check @bind-Checked="@HiddenPath">Show hiden path?</Check>
                        </Container>
                    </Container>
                    <Container Class="col-6 directory-modal-body-directories">
                        <Container Class="@("directory-modal-body-directories-back " + (Directory.Parent == null ? "disabled" : ""))" @onclick="ReturnToParent">
                            <Icon Name="@("fa-arrow-left")"></Icon>
                            <Text>Back</Text>
                        </Container>
                        <DirectoryDialog>
                            @foreach ( var item in Directory.Children ) {
                                <DirectoryItem Name="@item.Name" Path="@item.Path" />
                            }
                        </DirectoryDialog>
                    </Container>
                </Container>
                <Field>
                    <TextEdit Placeholder="Library's path" Text="@LibraryPath" Class="directory-modal-body-content-path" />
                </Field>
            </ModalBody>
            <ModalFooter>
                <Button Color="Color.Light" Clicked="@HideModal" Class="directory-modal-cancel-button">Cancel</Button>
                <Button Color="Color.Secondary" Clicked="@Save">Save</Button>
            </ModalFooter>
        </ModalContent>
        <ModalBackdrop />
    </Modal>
</CascadingValue>

@code {

    [Parameter]
    public EventCallback<string> OnSave { get; set; }

    [Parameter]
    public string DisksUrl { get; set; }

    [Parameter]
    public string RootFolderUrl { get; set; }

    [Parameter]
    public string FolderUrl { get; set; }

    private DirectoryResponse Directory { get; set; } = new DirectoryResponse( );
    private DisksResponse Disks { get; set; } = new DisksResponse( );
    private string LibraryPath { get; set; }
    private bool HiddenPath { get; set; }
    private Modal modalRef;

    public async void ShowModal( ) {
        var token = new CancellationToken( );
        var request = new GetRootDirectoryResponse( HiddenPath );
        Directory = await GetRootFolder( request, token );
        Disks = await GetDisks( token );
        StateHasChanged( );
        modalRef.Show( );
    }

    public void HideModal( ) {
        modalRef.Hide( );
    }

    private async void ReloadTree( string item ) {
        var token = new CancellationToken( );
        var request = new GetDirectoryResponse( item, HiddenPath );
        Directory = await GetFolder( request, token );
        StateHasChanged( );
    }

    public void ChangeLibraryPath( string item ) {
        LibraryPath = item;
        ReloadTree( item );
        StateHasChanged( );
    }

    public void ReturnToParent( ) {
        if ( Directory.Parent != null )
            ReloadTree( Directory.Parent.Path );
    }

    private async void Save( ) {
        HideModal( );
        await OnSave.InvokeAsync( LibraryPath );
    }

    public async Task<DisksResponse> GetDisks( CancellationToken cancellationToken ) =>
        await _client
            .RequestAsync( DisksUrl, cancellationToken )
            .ThenGet<DisksResponse>( );

    public async Task<DirectoryResponse> GetRootFolder( GetRootDirectoryResponse getRootDirectoryViewModel, CancellationToken cancellationToken ) =>
        await _client
            .RequestAsync( RootFolderUrl + getRootDirectoryViewModel.ToQuery( ), cancellationToken )
            .ThenGet<DirectoryResponse>( );

    public async Task<DirectoryResponse> GetFolder( GetDirectoryResponse getDirectoryViewModel, CancellationToken cancellationToken ) =>
        await _client
            .RequestAsync( FolderUrl + getDirectoryViewModel.ToQuery( ), cancellationToken )
            .ThenGet<DirectoryResponse>( );
}